# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) Camptocamp SA - http://www.camptocamp.com
# Author: Joel Grand-Guillaume, Gille Cherix
# 
#    This file is part of the c2c_budget module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
from osv import osv, fields

class smmanager_branch(osv.osv):
    _name = 'smmanager.branch'
    _description = 'SM Manager branch'
    
    _columns = {
        'name' : fields.char('Branch Name',size=30,required=True),
        'path' : fields.char('Path',size=255,required=True),
    }
smmanager_branch()


class smmanager_root_branch(osv.osv):
    def _check_recursion(self, cr, uid, ids):
        level = 100
        while len(ids):
            cr.execute('select distinct parent_root_branch_id from smmanager_root_branch where id in ('+','.join(map(str,ids))+')')
            ids = filter(None, map(lambda x:x[0], cr.fetchall()))
            if not level:
                return False
            level -= 1
        return True
    
    _name = 'smmanager.root_branch'
    _description = 'SM Manager Root branch'
    _table = 'smmanager_root_branch'
    	
    #_rec_name="path"
    _columns = {
        'name' : fields.char('Name',size=30),
        #'branch_name' : fields.char('Global Branch Name',size=30,required=True),
        'type' : fields.char('Type',size=30,required=True),
        #'path' : fields.char('Path',size=255,required=True),
        
        'parent_root_branch_id': fields.many2one('smmanager.root_branch', 'Parent Root Branch',required=False),
        
        'branch_ids' : fields.many2many('smmanager.branch','smmanager_branch_root_branch_rel','root_branch_id','branch_id','Branches'),
    
        #'server_id' : fields.many2one('smmanager.server','Server',required=True),
        #'project_id' : fields.many2one('smmanager.project','Project',required=True),
        }
    _constraints = [
        (_check_recursion, 'Error ! You can not create recursive global branches.', ['parent_root_branch_id'])
    ]
smmanager_root_branch()