# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) Camptocamp SA - http://www.camptocamp.com
# Author: Joel Grand-Guillaume, Gille Cherix
# 
#    This file is part of the c2c_budget module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
from osv import osv, fields

class smmanager_connection(osv.osv):
    _name = 'smmanager.connection'
    _description = 'SM Manager Connection'
    
    _columns = {
        'name' : fields.char('User Name',size=30,required=True), #FIXME: mettre par defaut un truc du genre "Connexion de machin a truc"
        'sequence' : fields.integer('Sequence',required=True),
        'server_id': fields.many2one('smmanager.server', 'Gateway server'),
        'destination_server_id': fields.many2one('smmanager.server', 'Destination server'),
    }
    
    # SHOULD: problem: ce qui nous interesse c'est surtout le lien vers le serveur que chaque lien individuel
	# donc il faut separer la connection qui est un ensemble de tunnels actifs et les hop (ou gateway) qui sont
	# les liens entre chaque serveur.
    # 'state': fields.selection([
	#	('up','Connected'),
	#	('down','Not connected'),
	#	('error','Exception')
	#	], 'Connection state', readonly=True, select=True),
	
    _order = 'sequence'
smmanager_connection()