# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) Camptocamp SA - http://www.camptocamp.com
# Author: Joel Grand-Guillaume, Gille Cherix
# 
#    This file is part of the c2c_budget module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
import datetime
from osv import osv, fields
import pooler

class smmanager_log(osv.osv):
    _name = 'smmanager.log'
    _description = 'SM Log'
    _rec_name = 'create_date'
    
    _columns = {
        'description' : fields.char('Description',size=500,required=True), #FIXME: mettre par defaut un truc du genre "Connexion de machin a truc"
        'create_date': fields.datetime('Timestamp', readonly=True),
        
        'level': fields.selection([
			(0,'ERROR'),
			(1,'WARNING'),
			(3,'INFO'),
			(4,'DEBUG')
			], 'Level', select=True),
        
        'server_id': fields.many2one('smmanager.server', 'Server'),
        'instance_id': fields.many2one('smmanager.instance', 'Instance'),
    }
    
    _defaults = {
        #'timestamp': lambda self, cr, uid, context: datetime.datetime.today(),
    #    'web_server_id': lambda self, cr, uid, context: context.get('id', False) and self.pool.get('smmanager.instance').browse(cr, uid, context['id']).openerp_server_id,
    }
smmanager_log()