# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) Camptocamp SA - http://www.camptocamp.com
# Author: Joel Grand-Guillaume, Gille Cherix
# 
#    This file is part of the c2c_budget module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import pooler

#
# Define some useful constants
#
ERROR = 0
INFO = 1
DEBUG = 2
ALL = 3

LOG_LEVEL = ALL

#
# FIXME: tres pratique mais pas tres elegant... factoriser!
#
def _browse_to_dict(h):
    ## recursively filter browse_record and browse_record_list into dicts, browse_null into None
    fetch_record = lambda r: r[r._rec_name]
    
    list_to_dict = lambda h: map(lambda r: fetch_record(r) and r._data[r.id] , h)
    
    if h[1].__class__.__name__ == 'browse_record':
        fetch_record(h[1])
        return (h[0], browse2dict(h[1], with_relations=True))
    elif h[1].__class__.__name__ == 'browse_record_list':
        return (h[0], list_to_dict(h[1]))
    elif h[1].__class__.__name__ == 'browse_null':
        return (h[0], None)
    else:
        return h

def browse2dict(browse_record, with_relations=False):
    ## utilise l'introspection python pour changer recursivement le browse_record en dict.
    browse_record[browse_record._rec_name] # refactor: fetch_record
    return dict(map(_browse_to_dict, browse_record._data[browse_record.id].iteritems()))

class SMLog():
    #
    # refactor this, either to reflect standard practice for the signature
    # or eliminate the need of cr as argument
    #
    def SMLog(cr, uid, message, level=4, instance_id=None, server_id=None):
        pool = pooler.get_pool(cr.dbname)
        log_obj = pool.get('smmanager.log')

        content = { 'description': message }

        if instance_id != None: content['instance_id'] = instance_id
        if server_id != None: content['server_id'] = server_id
        content['level'] = level
        
        log = log_obj.create(cr, uid, content)
    SMLog = staticmethod(SMLog)