# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) Camptocamp SA - http://www.camptocamp.com
# Author: Joel Grand-Guillaume, Gille Cherix
# 
#    This file is part of the c2c_budget module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
import wizard
import pooler
from smutils import *

import time
import os

#
# Connect
#
connected_form = '''<?xml version="1.0"?>
<form string="Connected">
    <separator string="You can now connect to the desired server with :" colspan="4"/>
    <field name="host_name"/>
    <field name="port"/>
    <newline/>
    <field name="database_name"/>
    <newline/>
    <field name="database_user"/>
    <newline/>
    <field name="database_password"/>
    <separator string="Please, close the tunnel when you don't need it anymore." colspan="4"/>
</form>'''

connected_fields = {
    'host_name': {'string': 'Host name', 'type':'char', 'size': 64 },
    'port': {'string': 'Port', 'type':'integer', 'size': 10 },
    'database_name': {'string': 'Database', 'type':'char', 'char': 64 },
    'database_user': {'string': 'User', 'type':'char', 'char': 64 },
    'database_password': {'string': 'Password', 'type':'char', 'size': 64 },
}

#
# Log
#
log_form = '''<?xml version="1.0"?>
<form string="Closed">
    <separator string="Tunnel successfully closed! Please tell us what you did with it." colspan="4"/>
    <field name="comment"/>
</form>'''

log_fields = {
    'comment': {'string': 'Comment', 'type':'char', 'size': 255 },
}

def _do_disconnect(self, cr, uid, data, context):
    # TODO: tester comme il faut et logguer l'exception
    try:
        # FIXME utiliser server.disconnect plutot
        map(lambda pid: time.sleep(2) or os.kill(pid, 3), data['form']['ssh_pids'])
    except Exception, e:
        pool = pooler.get_pool(cr.dbname)
        log_obj = pool.get('smmanager.log')
        log = log_obj.create(cr, uid, { 'description' : e or "Exception on killing ssh tunnel process." })
        
    return {}

def _do_connect(self, cr, uid, data, context):
    pool = pooler.get_pool(cr.dbname)
    instance_obj = pool.get('smmanager.instance')
    instance = instance_obj.browse(cr, uid, data['ids'][0])

    return  instance.connect_database()

def _do_log(self, cr, uid, data, context):
    pool = pooler.get_pool(cr.dbname)
    log_obj = pool.get('smmanager.log')
    log = log_obj.create(cr, uid, { 'description' : data['form']['comment'] or "User did not comment on connection usage.", 'instance_id': data['ids'][0] })
    
    return {}

def _do_cleanup(self, cr, uid, data, context):
    # FIXME: Implements ssh process cleanup in case of failure something like :
#    map(lambda pid: time.sleep(2) or os.kill(pid, 9), data['form']['ssh_pids'])
    return {}

def _open_log(self, cr, uid, data, context):
    return {
                    #'domain': "[('id','in', ["+','.join(map(str,newinv))+"])]",
                    'name': 'Log',
                    'view_type': 'tree',
                    'view_mode': 'form,tree',
                    'res_model': 'smmanager.log',
                    #'view_id': False,
                    #'context': "{'type':'out_refund'}",
                    'type': 'ir.actions.act_window'
            }

class SmManager_connect_database(wizard.interface):
    states = {
        #'init': {
        #    'actions': [],
        #    'result': {'type': 'form', 'arch': wiz_form, 'fields': wiz_fields, 'state': (('end', 'Cancel'), ('go', 'Archive'))},
        #},
        'init': {
                'actions': [_do_connect],
                'result': {'type': 'form',
                           'arch': connected_form,
                           'fields': connected_fields,
                           'state': [('close', 'Close tunnel')] },
            },

        'close': {
                'actions': [_do_disconnect],
                'result': {'type': 'form',
                           'arch': log_form,
                           'fields': log_fields,
                           'state': [('log', 'Ok')] },
        },
        
        'log': {
                'actions': [_do_log],
                'result': {'type': 'state', 'state': 'end'},
        },
        
        'error': {
                'actions': [_do_cleanup],
                'result': {'type': 'action', 'action': _open_log, 'state': 'end'},
        },
    }
SmManager_connect_database('smmanager.connect_database')
