# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) Camptocamp SA - http://www.camptocamp.com
# Author: Joel Grand-Guillaume, Gille Cherix
# 
#    This file is part of the c2c_budget module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
import wizard
import pooler

from smutils import *

wiz_form = '''<?xml version="1.0"?>
<form string="deploy instance">
    <separator string="If you want to deploy from an archive file :" colspan="4"/>
    <field name="archive_id" width="170"/>
</form>'''

wiz_fields = {
    'archive_id': {'string':'Archive', 'type':'many2one', 'relation':'smmanager.archive'}
}

def _do_deploy(self, cr, uid, data, context):
    form =  data['form']
    
    #if form['free_instance'] and form['instance']:
    #    raise wizard.except_wizard('UserError',
	#				'Please choose between free insance or existing instance') 
    #if form['instance'] and form['create_inst']:
    #    raise wizard.except_wizard('UserError',
	#				'You can only create instance from free instance') 
    #if len(data['ids']) > 1:
    #    raise wizard.except_wizard('UserError',
	#				'Please select only one instance')
    #pool = pooler.get_pool(cr.dbname)
    #instance_obj = pool.get('smmanager.instance')
    #instance = instance_obj.browse(cr, uid, data['ids'][0])
    #util_test = smutils.command_line_utils.CommandUtils()
    #print util_test
    
    pool = pooler.get_pool(cr.dbname)
    instance_obj = pool.get('smmanager.instance')
    instance = instance_obj.browse(cr, uid, data['ids'][0])
    
    #if instance.state != 'draft':
    #    raise wizard.except_wizard('Error', 'You can only deploy instance in draft state')
	
    #
    # connect openerp client server
    #
    connection = instance.openerp_server_id.connect()
    
    #
    # deploy a new instance
    #
    instance.deploy({ 'form': form, 'connection' : connection })
    
    #
    # disconnect openerp client server
    #
    instance.openerp_server_id.disconnect(context = connection)

    print data 
    return {}

class SmManager_deploy_instance(wizard.interface):
    states = {
        'init': {
            'actions': [],
            'result': {'type': 'form', 'arch': wiz_form, 'fields': wiz_fields, 'state': (('end', 'Cancel'), ('go', 'Deploy'))},
        },
        
        'already_deployed': None,
        
        'go': {
            'actions': [_do_deploy],
            'result': {'type': 'state', 'state': 'end'},
        },
        
        'done': None
    }
SmManager_deploy_instance('smmanager.deploy_instance')
