# -*- coding: utf-8 -*- 
##############################################################################
#
# Copyright (c) Camptocamp SA - http://www.camptocamp.com
# Author: Joel Grand-Guillaume, Gille Cherix
# 
#    This file is part of the c2c_budget module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
import socket
import py
import admin

def remoteAdmin(connection, command):
    # open a gateway to a fresh child process
    gw = py.execnet.SshGateway("%s:%s@%s:%s" % (connection['ssh_user'], connection['ssh_password'], connection['host_name'], connection['port']))

    status = []
    try:
        channel = gw.remote_exec(admin)
        channel.send(command)
                
        output = channel.receive()

        while output:
            status.append(output)
            output = channel.receive()
    except Exception, e:
        status.append(str(e))
        #raise Exception(status)
    #finally:
        #gw.exit()
    
    return status

def ssh_tunnel(host_name, username, port, local_port, remote_host, remote_port, remote_connection=False):
    #return "ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -L %s:%s:%s -u %s -p %s %s" % (local_port, remote_host, remote_port, username, port, host_name)
    args = ["ssh", "-N", "-A", "-o UserKnownHostsFile=/dev/null", "-o StrictHostKeyChecking=no", "-p %s" % port, "%s@%s" % (username, host_name)]
    if (remote_connection):
        # FIXME: should be done in only one place
        local_host_name = socket.gethostbyaddr(socket.gethostname())[2][0]
        
        args.append("-g")
        args.append("-L %s:%s:%s:%s" % (local_host_name, local_port, remote_host, remote_port))
    else:
        args.append("-L %s:%s:%s" % (local_port, remote_host, remote_port))
    return args

#
# discover free ports by trying to open a local socket
#
def free_ports(number=1):
    probes = []

    for i in range(0, number):
        probes.append(socket.socket())
        try:
            probes[i].bind(('127.0.0.1', 0))
        except:
            continue
    
    ports = map(lambda s: s.getsockname()[1], probes)

    for p in probes:
        p.close()

    return ports